#include "stdafx.h"

#define MAX_WINDOW_TEXT 4096
#define MAX_INDENT       256
#define LINE            "============================================================"
#define CRLF            "\r\n"
#define STRLEN_BYTE(S)  (strlen(S) * sizeof((S)[0]))

static BOOL CALLBACK CallbackHandler(HWND hWnd, LPARAM context);
static HANDLE m_FileHandle = INVALID_HANDLE_VALUE;

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow )
{
	m_FileHandle = CreateFile("WinSpy.log", GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if(m_FileHandle == INVALID_HANDLE_VALUE) return -1;

	EnumWindows(&CallbackHandler, (LPARAM)0);

	FlushFileBuffers(m_FileHandle);
	CloseHandle(m_FileHandle);

	return 0;
}

BOOL CALLBACK CallbackHandler(HWND hWnd, LPARAM context)
{
	static level = -1;
	level++;
	TCHAR szText[MAX_WINDOW_TEXT];
	memset(szText, 0, sizeof(szText));
	int c = SendMessage(hWnd, WM_GETTEXT, (WPARAM)sizeof(szText) - 1, (LPARAM)szText);
	if(c > 0)
	{
		TCHAR szIndent[MAX_INDENT];
		memset(szIndent, 0, sizeof(szIndent));
		for(int i = 0; i < level && i < MAX_INDENT; i++)
		{
			szIndent[i] = '\t';
		}

		DWORD cbWritten = 0;
		if(level == 0)
		{
			(void)WriteFile(m_FileHandle, LINE, STRLEN_BYTE(LINE), &cbWritten, NULL);
			(void)WriteFile(m_FileHandle, CRLF, STRLEN_BYTE(CRLF), &cbWritten, NULL);
		}
		(void)WriteFile(m_FileHandle, szIndent, STRLEN_BYTE(szIndent), &cbWritten, NULL);
		(void)WriteFile(m_FileHandle, szText, STRLEN_BYTE(szText), &cbWritten, NULL);
		(void)WriteFile(m_FileHandle, CRLF, STRLEN_BYTE(CRLF), &cbWritten, NULL);

		EnumChildWindows(hWnd, &CallbackHandler, (LPARAM)0);
	}
	level--;
	return true;
}